<?xml version="1.0" encoding="UTF-8"?>
<!--
~ Copyright (c) 2019, Entgra (pvt) Ltd. (http://entgra.io) All Rights Reserved.
~
~ Entgra (pvt) Ltd. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~    http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied.  See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <parent>
        <groupId>org.wso2.carbon.devicemgt</groupId>
        <artifactId>application-mgt</artifactId>
        <version>4.1.10-SNAPSHOT</version>
    </parent>
    <artifactId>org.wso2.carbon.device.application.mgt.publisher.ui</artifactId>
    <version>4.1.10-SNAPSHOT</version>
    <packaging>war</packaging>
    <name>WSO2 Carbon - Application Management Publisher UI Component</name>
    <url>https://entgra.io</url>
    <description>This Component contains Application Management publisher UI</description>
    <build>
        <plugins>
            <plugin>
                <artifactId>maven-war-plugin</artifactId>
                <configuration>
                    <packagingExcludes>WEB-INF/lib/*cxf*.jar</packagingExcludes>
                    <warName>publisher</warName>
                    <webResources>
                        <resource>
                            <directory>${npm.output.directory}/dist</directory>
                        </resource>
                        <resource>
                            <directory>${npm.output.directory}/public</directory>
                            <targetPath>public</targetPath>
                        </resource>
                    </webResources>
                </configuration>
            </plugin>
            <plugin>
                <groupId>com.github.eirslett</groupId>
                <artifactId>frontend-maven-plugin</artifactId>
                <version>${frontend.mave.version}</version>
                <configuration>
                    <workingDirectory>${npm.working.dir}</workingDirectory>
                    <!-- where to install npm -->
                    <installDirectory>${npm.install.dir}</installDirectory>
                </configuration>
                <executions>
                    <execution>
                        <id>install node and npm</id>
                        <goals>
                            <goal>install-node-and-npm</goal>
                        </goals>
                        <phase>generate-resources</phase>
                        <configuration>
                            <nodeVersion>${node.version}</nodeVersion>
                            <npmVersion>${npm.version}</npmVersion>
                        </configuration>
                    </execution>
                    <execution>
                        <id>npm install</id>
                        <goals>
                            <goal>npm</goal>
                        </goals>
                        <!-- Optional configuration which provides for running any npm command -->
                        <configuration>
                            <arguments>install</arguments>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lint</id>
                        <goals>
                            <goal>npm</goal>
                        </goals>
                        <configuration>
                            <arguments>run-script lint</arguments>
                        </configuration>
                        <phase>generate-resources</phase>
                    </execution>
                    <execution>
                        <id>prod</id>
                        <goals>
                            <goal>npm</goal>
                        </goals>
                        <configuration>
                            <arguments>run-script ${npm.build.command}</arguments>
                        </configuration>
                        <phase>generate-resources</phase>
                    </execution>
                </executions>
            </plugin>
<!--            <plugin>-->
<!--                <groupId>org.codehaus.mojo</groupId>-->
<!--                <artifactId>exec-maven-plugin</artifactId>-->
<!--                <version>1.5.0</version>-->
<!--                <executions>-->
<!--                    <execution>-->
<!--                        <id>npm install (initialize)</id>-->
<!--                        <goals>-->
<!--                            <goal>exec</goal>-->
<!--                        </goals>-->
<!--                        <phase>initialize</phase>-->
<!--                        <configuration>-->
<!--                            <workingDirectory>react-app</workingDirectory>-->
<!--                            <executable>${npm.executable}</executable>-->
<!--                            <arguments>-->
<!--                                <argument>install</argument>-->
<!--                                <argument>&#45;&#45;silent</argument>-->
<!--                            </arguments>-->
<!--                        </configuration>-->
<!--                    </execution>-->
<!--                    <execution>-->
<!--                        <id>npm run build (compile)</id>-->
<!--                        <goals>-->
<!--                            <goal>exec</goal>-->
<!--                        </goals>-->
<!--                        <phase>compile</phase>-->
<!--                        <configuration>-->
<!--                            <workingDirectory>react-app</workingDirectory>-->
<!--                            <executable>${npm.executable}</executable>-->
<!--                            <arguments>-->
<!--                                <argument>run</argument>-->
<!--                                <argument>${npm.build.command}</argument>-->
<!--                            </arguments>-->
<!--                        </configuration>-->
<!--                    </execution>-->
<!--                </executions>-->
<!--                <configuration>-->
<!--                    <workingDirectory>${npm.working.dir}</workingDirectory>-->
<!--                </configuration>-->
<!--            </plugin>-->
        </plugins>
    </build>
    <profiles>
        <profile>
            <id>platform-windows</id>
            <activation>
                <os>
                    <family>windows</family>
                </os>
            </activation>
            <properties>
                <!-- Override the executable names for Windows -->
                <npm.executable>npm.cmd</npm.executable>
            </properties>
        </profile>
    </profiles>
    <properties>
        <maven.test.skip>false</maven.test.skip>
        <npm.executable>npm</npm.executable>
        <npm.build.command>build_prod</npm.build.command>
        <npm.working.dir>./react-app</npm.working.dir>
        <npm.install.dir>./react-app/tmp</npm.install.dir>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <npm.output.directory>react-app</npm.output.directory>
    </properties>
</project>
